package com.hai.service.impl;

import com.hai.dao.HighDiscountAgentRelMapper;
import com.hai.entity.HighAgent;
import com.hai.entity.HighDiscount;
import com.hai.entity.HighDiscountAgentRel;
import com.hai.entity.HighDiscountAgentRelExample;
import com.hai.service.HighAgentService;
import com.hai.service.HighDiscountAgentRelService;
import com.hai.service.HighDiscountService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @Auther: 胡锐
 * @Description:
 * @Date: 2021/4/4 00:15
 */
@Service("highDiscountAgentRelService")
public class HighDiscountAgentRelServiceImpl implements HighDiscountAgentRelService {

    @Resource
    private HighDiscountAgentRelMapper highDiscountAgentRelMapper;

    @Resource
    private HighAgentService highAgentService;

    @Resource
    private HighDiscountService highDiscountService;

    @Override
    public void insertDiscountAgentRel(HighDiscountAgentRel highDiscountAgentRel) {
        highDiscountAgentRelMapper.insert(highDiscountAgentRel);
    }

    @Override
    public void updateDiscountAgentRel(HighDiscountAgentRel highDiscountAgentRel) {
        highDiscountAgentRelMapper.updateByPrimaryKey(highDiscountAgentRel);
    }

    @Override
    public void deleteDiscountAgentRel(Long id) {
        highDiscountAgentRelMapper.deleteByPrimaryKey(id);
    }

    @Override
    public HighDiscountAgentRel getRelByDiscountAgent(Long discountId, Long agentId) {
        HighDiscountAgentRelExample example = new HighDiscountAgentRelExample();
        example.createCriteria().andDiscountIdEqualTo(discountId).andAgentIdEqualTo(agentId);
        List<HighDiscountAgentRel> list = highDiscountAgentRelMapper.selectByExample(example);
        if (list != null && list.size() >0) {
            return list.get(0);
        }
        return null;
    }

    @Override
    public HighDiscountAgentRel getRelById(Long id) {
        HighDiscountAgentRel rel = highDiscountAgentRelMapper.selectByPrimaryKey(id);
        if (rel != null) {
            rel.setHighDiscount(highDiscountService.getDiscountById(rel.getDiscountId()));
            rel.setHighAgent(highAgentService.findByAgentMsgId(rel.getAgentId()));
        }
        return rel;
    }

    @Override
    public List<HighDiscountAgentRel> getRelList(Map<String, Object> map) {
        HighDiscountAgentRelExample example = new HighDiscountAgentRelExample();
        HighDiscountAgentRelExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map, "discountId") != null) {
            criteria.andDiscountIdEqualTo(MapUtils.getLong(map, "discountId"));
        }

        if (MapUtils.getLong(map, "agentId") != null) {
            criteria.andAgentIdEqualTo(MapUtils.getLong(map, "agentId"));
        }

        criteria.andStatusEqualTo(1);
        example.setOrderByClause("create_time desc");
        List<HighDiscountAgentRel> list = highDiscountAgentRelMapper.selectByExample(example);
        for (HighDiscountAgentRel rel : list) {
            rel.setHighDiscount(highDiscountService.getDiscountById(rel.getDiscountId()));
            rel.setHighAgent(highAgentService.findByAgentMsgId(rel.getAgentId()));
        }
        return list;
    }
}
